VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "File Delation via control drag and drop"
   ClientHeight    =   6300
   ClientLeft      =   132
   ClientTop       =   708
   ClientWidth     =   7380
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   10.2
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   6300
   ScaleWidth      =   7380
   StartUpPosition =   3  'Windows Default
   Visible         =   0   'False
   Begin VB.CommandButton cmdFileName 
      BackColor       =   &H00FFFFC0&
      Caption         =   "Command1"
      DragMode        =   1  'Automatic
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   7.8
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   612
      Index           =   0
      Left            =   120
      Picture         =   "Directions.frx":0000
      Style           =   1  'Graphical
      TabIndex        =   0
      Top             =   0
      Visible         =   0   'False
      Width           =   972
   End
   Begin VB.Image imgGarbage 
      Height          =   384
      Left            =   6600
      Picture         =   "Directions.frx":0442
      Top             =   7080
      Width           =   384
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuNewFileSpec 
         Caption         =   "New File Spec"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const Spacing = 35
'USED FOR POSITIONING THE CONTROLS
Private fCurrentWidth As Integer
Private fCurrentRow As Integer
Private fCurrentHeight As Integer
Private fLastRow As Integer
Private fCurrentPath As String

Private Sub cmdFileName_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
If Button = vbRightButton Then
  Dim FileName  As String
  Dim Temp As String
  Dim Attrib As Integer
  
  FileName = fCurrentPath & cmdFileName(Index).Caption
  Attrib = GetAttr(FileName)
  Temp = FileName & vbCrLf & vbCrLf
  Temp = Temp & "Date/Time: " & FileDateTime(FileName) & vbCrLf
  Temp = Temp & "Size: " & FileLen(FileName) & " bytes" & vbCrLf
  If (Attrib And vbReadOnly) = vbReadOnly Then
    Temp = Temp & "ReadOnly: Yes" & vbCrLf
  End If
  If (Attrib And vbHidden) = vbHidden Then
    Temp = Temp & "Hidden: Yes" & vbCrLf
  End If
  If (Attrib And vbSystem) = vbSystem Then
    Temp = Temp & "System: Yes" & vbCrLf
  End If
  If (Attrib And vbArchive) = vbArchive Then
    Temp = Temp & "Archive: Yes" & vbCrLf
  End If
  MsgBox Temp
End If
End Sub

Private Sub Form_Load()
  'will number rows from 0 to n-1 since static variables start at 0
  fLastRow = (ScaleHeight / (cmdFileName(0).Height + Spacing)) - 1
  Load frmDirections
  Me.Hide
  Directions
End Sub


Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  Unload frmDirections
  Unload Me
  End
End Sub

Private Sub Form_Resize()
  frmMain.imgGarbage.Move ScaleWidth - _
  imgGarbage.Width - Spacing, ScaleHeight - imgGarbage.Height
End Sub


Private Sub mnuExit_Click()
  Unload Me
End Sub

Private Sub mnuNewFileSpec_Click()
  On Error Resume Next
  Dim AControl As Control
  For Each AControl In frmMain.Controls
    Unload AControl
  Next
  On Error GoTo 0
  'reset form level variables for positioning
  fCurrentRow = 1
  fCurrentWidth = 0
  fCurrentHeight = 0
  fCurrentPath = vbNullString
  mnuGetFile
End Sub

Private Sub mnuHelp_Click()
  Directions
End Sub

Private Sub mnuGetFile()
  'local variables
  Dim FileSpec As String
  Dim Message As String
  frmDirections.Hide
  FileSpec = InputBox$("File specification? (You can use wild cards of course-C:\temp\*.tmp for example.")
  fCurrentPath = Left(FileSpec, InStrRev(FileSpec, "\"))
  If fCurrentPath = vbNullString Then
    Message = FileSpec & " is NOT a valid file spec "
    Message = Message & "(did you forget the '\')? "
    Message = Message & "Remember file specs are things like "
    Message = Message & "C:\1temp\*.* or c:\*.tmp. "
    Message = Message & "Click on OK to reshow directions."
    MsgBox Message
    Directions
  Else
    frmMain.Show
    DisplayFiles (FileSpec)
  End If
End Sub

Private Sub imgGarbage_DragDrop(Source As Control, X As _
Single, Y As Single)
  
  On Error GoTo Problems
  Dim Msg As String, ErrorMessage As String
  Dim ControlIndex As Integer, YesNo As Integer
  ControlIndex = Source.Index
  cmdFileName(ControlIndex).Visible = False
  Msg = "Do you really want to delete " & _
  cmdFileName(ControlIndex).Caption & "?"
  YesNo = MsgBox(Msg, vbYesNo, "Confirmation Box")
  If YesNo = vbYes Then
    Kill (fCurrentPath & cmdFileName(ControlIndex).Caption)
    Unload cmdFileName(ControlIndex)
  Else
    cmdFileName(ControlIndex).Visible = True
  End If
  Exit Sub
Problems:
  ErrorMessage = "Sorry can't delete that file"
  cmdFileName(ControlIndex).Visible = True
  MsgBox ErrorMessage
End Sub

Private Sub DisplayFiles(FileSpec As String)
  'local variables
  Dim I As Integer, Message As String
  Dim ControlIndex As Integer, NameOfFile As String
  On Error GoTo Problems
   
  NameOfFile = Dir$(FileSpec)
  If NameOfFile = vbNullString Then
    MsgBox "No Files found with that file specification!"
    Exit Sub
  End If
  
  Do Until NameOfFile = vbNullString Or fCurrentRow > fLastRow
    ControlIndex = ControlIndex + 1
    Load cmdFileName(ControlIndex)
    'make button 10% larger than width of caption
    cmdFileName(ControlIndex).Width = TextWidth(NameOfFile & "XX")
    cmdFileName(ControlIndex).Caption = NameOfFile
    If Not (CanPosition(ControlIndex)) Then
      Message = "To many files with that specification. "
      Message = Message & "am showing only " & (ControlIndex - 1)
      Message = Message & " files with that specification."
      MsgBox Message
      Exit Sub
    Else
      cmdFileName(ControlIndex).Visible = True
    End If
    NameOfFile = Dir$
  Loop
  Exit Sub
Problems:
  MsgBox Err.Description
  End
 End Sub
Private Function CanPosition(TheIndex As Integer) As Boolean

  'take care of first button
  If TheIndex = 1 Then
      cmdFileName(TheIndex).Move 0, 0
      fCurrentWidth = cmdFileName(TheIndex).Width + fCurrentWidth + Spacing
      CanPosition = True
      Exit Function
  End If
  'now work with all other buttons
  Select Case fCurrentRow
     Case fLastRow
       If cmdFileName(TheIndex).Width + fCurrentWidth + Spacing + imgGarbage.Width <= ScaleWidth Then
         'have room on last row so add
         fCurrentWidth = fCurrentWidth + Spacing
         cmdFileName(TheIndex).Move fCurrentWidth, fCurrentHeight
         ' set new current width to add width of control
         fCurrentWidth = cmdFileName(TheIndex).Width + fCurrentWidth + Spacing
         CanPosition = True
       Else
         CanPosition = False
         fCurrentRow = fCurrentRow + 1 'out of space
       End If
     Case Is < fLastRow
        If cmdFileName(TheIndex).Width + fCurrentWidth + Spacing >= ScaleWidth Then
        'need to move to next row
          fCurrentRow = fCurrentRow + 1
          fCurrentWidth = 0
          fCurrentHeight = fCurrentHeight + cmdFileName(TheIndex).Height + Spacing
          cmdFileName(TheIndex).Move fCurrentWidth, fCurrentHeight
          ' set new current width to add width of control
          fCurrentWidth = cmdFileName(TheIndex).Width + fCurrentWidth
          CanPosition = True
        Else
          fCurrentWidth = fCurrentWidth + Spacing
          cmdFileName(TheIndex).Move fCurrentWidth, fCurrentHeight
          fCurrentWidth = cmdFileName(TheIndex).Width + fCurrentWidth + Spacing
          CanPosition = True
        End If
     Case Else
       MsgBox "OOps shouldn't get to this case"
     End Select
End Function
Private Sub Directions()
  frmDirections.Show
End Sub




