VERSION 5.00
Begin VB.Form frmFractal2 
   Caption         =   "Fractal 2 - the 'C' Curve"
   ClientHeight    =   3192
   ClientLeft      =   60
   ClientTop       =   348
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3192
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "frmFractal2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Function MoveX(X1!, Y1!, X2!, Y2!) As Single
  ' local variables: Angle(in radians),D,XShift,YShift
  Dim Angle As Single, D As Single, R As Single
  Dim XShift As Single, YShift As Single
  Angle = Radians(45)
  D = Dist(X1!, Y1!, X2!, Y2!)
  R = (Sqr(2) / 2) * D
  XShift = Cos(Angle) * (X2! - X1!)
  YShift = Sin(Angle) * (Y2! - Y1!)
MoveX = R / D * (XShift - YShift)
End Function

Function MoveY(X1!, Y1!, X2!, Y2!) As Single
  ' local variables: Angle(in radians),D,XShift,YShift
  Dim Angle As Single, D As Single, R As Single
  Dim XShift As Single, YShift As Single
  Angle = Radians(45)
  D = Dist(X1!, Y1!, X2!, Y2!)
  R = (Sqr(2) / 2) * D
  XShift = Sin(Angle) * (X2! - X1!)
  YShift = Cos(Angle) * (Y2! - Y1!)

  MoveY = (R / D) * (XShift + YShift)
End Function
Function Dist(X1!, Y1!, X2!, Y2!) As Single
  ' finds the distance between points
  ' local variables are: x,y
  Dim X As Single, Y As Single
  X = (X2! - X1!) * (X2! - X1!)
  Y = (Y2! - Y1!) * (Y2! - Y1!)
  Dist = Sqr(X + Y)
End Function

Function Radians!(X!)
  ' converts degrees to radians
  ' Needs global variable PI = 4*Atn(1)
  Dim PI
  PI = 3.14
  Radians! = X! * PI / 180
End Function
Sub Curve(X1!, Y1!, X2!, Y2!)
  Dim DistPt As Single, NX1 As Single, NY1 As Single
  DistPt = Dist(X1!, Y1!, X2!, Y2!)
  If DistPt < 10 Then
    Exit Sub
  End If
  NX1 = X1 + MoveX(X1!, Y1!, X2!, Y2!)      'find the coord for
  NY1 = Y1 + MoveY(X1!, Y1!, X2!, Y2!)      'the spike
  ' If these are in a module replace Line with FormName.Line
    Line (X1!, Y1!)-(X2!, Y2!), BackColor   'erase previous line
    Line (X1!, Y1!)-(NX1, NY1)              'make the spike
    Line -(X2!, Y2!)
  Curve X1!, Y1!, NX1, NY1                  'now recurse on the
  Curve NX1, NY1, X2!, Y2!                  'spikes
End Sub
Private Sub Form_Click()
  Dim X1!, X2!, Y1!, Y2!
  Scale (-500, 500)-(500, -500)
  X1! = -250: Y1! = -200
  X2! = 250: Y2! = -200
  Curve X1!, Y1!, X2!, Y2!
End Sub

Private Sub form_load()
  MsgBox "Please click inisde the form to see a 'C' curve fractal."
End Sub

